/*
 * Copyright 2008-2009, Peter Rowntree.
 * http://www.hdyn.com/mail/contact.php?addr=pr
 * License: you may not use this file except in compliance with
 * the Apache License, Version 2.0, a copy of which you may obtain at
 *   http://www.apache.org/licenses/LICENSE-2.0
 */

//----------for toggle hierarchy------------------------------------------------

function toggleSib(ob)
{
	var sub=ob.nextSibling;
	var s=sub.style;
	s.display=s.display == "block" ? "none" : "block";
	if(typeof g_activeBGColor == "undefined")
		return;
	if(s.display == "block")
		ob.style.backgroundColor=g_activeBGColor;
	else
		ob.style.backgroundColor="";
}

//---------for dynamic hierarchy------------------------------------------------
 
var g_hideTimer=new GPTimer();
window.onbeforeunload=hideAllSubs;
var g_ceiling=null;
var g_ceilingArr=null;

function showSib(ob)
{
	g_ceiling=ob;
	var sub=ob.nextSibling;
	if(sub.className.substr(0,4) == "bloc")
		moveSub(ob,sub);
	sub.style.display="block";
	if(typeof g_activeBGColor != "undefined")
		ob.style.backgroundColor=g_activeBGColor;
}

function hold(ob)
{
	g_ceiling=ob.previousSibling;
}

function rc(e)
{
	if(!e)
		e=window.event;
	var tgt=evtTarget(e);
	var c=tgt.className.substr(0,4);
	switch(c)
	{
		case "ceil":
			showSib(tgt);
			doHideTimer();
			break;
		case "block":
		case "block block2":
			hold(tgt);
			break;
		default:
			tgt=tgt.parentNode;
			if(tgt.className.substr(0,4) == "bloc")
				hold(tgt);
	}
}

function buildCeilingArr()
{
	g_ceilingArr=[];
	var navOb=document.getElementById("nav");
	if(!navOb)
		return;
	var els=navOb.getElementsByTagName('div');
	for(var i=0; i<els.length; i++)
	{
		if(els[i].className.substr(0,4) == "ceil")	//must match html
			g_ceilingArr.push(els[i]);
	}
}

function hideSib(ob)
{
	var sub=ob.nextSibling;
	sub.style.display="none";
	ob.style.backgroundColor="";
}

function hideAllSubs()
{
	g_ceiling=null;
	hideSubs();
}

function hideSeniorSibSubs(i,ob)
{
	var parent=ob.parentNode;
	for( ; i>=0; i--)
	{
		if(g_ceilingArr[i].parentNode == parent)
		hideSib(g_ceilingArr[i]);
	}
}

function hideSubs()
{
	if(g_ceilingArr == null)
		buildCeilingArr();
	for(var i=g_ceilingArr.length-1; i>=0; i--)
	{
		if(g_ceiling != null && g_ceiling == g_ceilingArr[i])
		{
			hideSeniorSibSubs(i-1,g_ceiling);	//skip this one but check for senior sibs
			break;
		}
		hideSib(g_ceilingArr[i]);
	}
}

var g_i=0;
function report(s)
{
	document.getElementById("db").innerHTML=(++g_i)+" "+s;
}

function evtTarget(e)
{
	if(typeof e.target != "undefined")
		return e.target;
   return e.srcElement;	//IE 6
}

//----------------------type 3--------------------------------------------------

function moveSub(ob,sub)
{
	var holder=ob.parentNode;
	var x=offsetToRootX(ob,holder)+ob.offsetWidth-1;
	var y=offsetToRootY(ob,holder)+2;
	sub.style.left=x+"px";
	sub.style.top=y+"px";
}

function offsetToRootX(ob,root)
{
	var x=0;
	do
	{
		x+=ob.offsetLeft;
		ob=ob.offsetParent;
	}
	while(ob != null && ob != root);
	return x;
}

function offsetToRootY(ob,root)
{
	var y=0;
	do
	{
		y+=ob.offsetTop;
		ob=ob.offsetParent;
	}
	while(ob != null && ob != root);
	return y;
}

//-----------------the hide timer-----------------------------------------------

function doHideTimer()
{
	htStop();
	hideSubs();
}

function htStart()
{
	g_ceiling=null;
	g_hideTimer.doAfter("doHideTimer()",180);
}

function htStop()
{
	var alreadyStopped=g_hideTimer.i_timer == null;
	g_hideTimer.clear();
	return !alreadyStopped;
}

function GPTimer()
{
	this.i_timer=null;
	this.doAfter=function(execStr,delay)
	{
		this.clear();
		this.i_timer=setTimeout(execStr,delay);
	}
	this.clear=function()
	{
		if(this.i_timer != null)
		{
			clearTimeout(this.i_timer);
			this.i_timer=null;
		}
	}
}

//-----------------helpers------------------------------------------------------

function moveNav(newParentID)
{
	var navOb=document.getElementById("nav");
	if(!navOb)
		return;
	var parentOb=document.getElementById(newParentID);
	if(!parentOb || parentOb == navOb.parentNode)
		return;
	parentOb.appendChild(navOb.parentNode.removeChild(navOb));
}